#include <QFileDialog>
#include "magicbytes.h"
#include "keyexplorer.h"
#include "ui_keyexplorer.h"
#include "encryptdecrypt.h"


cKeyExplorer::cKeyExplorer(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::cKeyExplorer)
{
    ui->setupUi(this);
}

cKeyExplorer::~cKeyExplorer()
{
    delete ui;
}

void cKeyExplorer::on_keySelectButton_clicked()
{
    QString fileName = QFileDialog::getOpenFileName(this, tr("Open Receiver Key File"),
                                                    "",
                                                    tr("Sender key files (*.key)"));
    ui->keySelectLineEdit->setText( fileName );


    cStreamEncryptor::sKey keyStruct;

    QFile file( fileName );

    if ( ! file.open( QIODevice::ReadOnly ) )
    {
        ui->keyInfoTextEdit->setText( QObject::tr( "Can not open file." ) );
        return;
    }

    QDataStream fileDataStream( &file );

    qint64 magicByte;
    fileDataStream >> magicByte >> keyStruct.length >> keyStruct.pos >> keyStruct.key;

    file.close();

    if ( magicByte != KEYSIG )
    {
        ui->keyInfoTextEdit->setText( QObject::tr( "Bad sender keyfile." ) );
        return;
    }

    QString message;
    message = "Key full length (bytes) " + QString::number( keyStruct.length )+"\n";
    message += "Key current position (bytes) "+QString::number ( keyStruct.pos )+"\n\n";

    message += "Key remaining:\n" + QString::number( keyStruct.length - keyStruct.pos ) + " bytes\n" +
            QString::number( ( keyStruct.length - keyStruct.pos ) / 1024.0, 'f', 4 ) + " KB\n" +
            QString::number( ( keyStruct.length - keyStruct.pos ) / ( 1024.0 *1024.0 ), 'f',4 ) + " MB \n" +
            "Remaining percent: ";
    if ( keyStruct.length > 0 )
    {
        message += QString::number( ( keyStruct.length - keyStruct.pos ) / ( keyStruct.length/100 ) )+"%";
    }
    else
    {
        message +=" (NA%)";
    }

    ui->keyInfoTextEdit->setText( message );

    return;

}
