#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "randomizer.h"
#include "encryptdialog.h"
#include "textdecryptdialogform.h"
#include "aboutdialog.h"


cMainWindow::cMainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::cMainWindow)
{
    ui->setupUi(this);
    QObject::connect( ui->actionEncrypt, SIGNAL( triggered() ), this, SLOT( encrypt() ) );
    QObject::connect( ui->actionDecrypt, SIGNAL( triggered() ), this, SLOT( decrypt() ) );
    QObject::connect( ui->actionGenerate_Keys , SIGNAL( triggered() ), this, SLOT( genKeys() ) );
    explorer_ = new cKeyExplorer();
    ui->horizontalLayout->insertWidget( 0, explorer_ );

}

cMainWindow::~cMainWindow()
{
    delete ui;
    explorer_->deleteLater();
}

void cMainWindow::encrypt()
{
    cEncryptDialog d(this);
    d.exec();
}

void cMainWindow::decrypt()
{
    cTextDecryptDialogForm form( this );
    form.exec();
}

void cMainWindow::genKeys()
{
    cFinalKeyGenerator * gen = new cFinalKeyGenerator();
     gen->gen();
}


void cMainWindow::on_actionAbout_triggered()
{

    cAboutDialog *dialog = new cAboutDialog( 0 );
    dialog->show();
}
