#include "newkeygenerationdialog.h"
#include "ui_newkeygenerationdialog.h"
#include "randomizer.h"
#include <QFileDialog>
#include <QDir>
#include <QDebug>


cNewKeyGenerationDialog::cNewKeyGenerationDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::cNewKeyGenerationDialog)
{
    ui->setupUi(this);
}

cNewKeyGenerationDialog::~cNewKeyGenerationDialog()
{
    delete ui;
}

void cNewKeyGenerationDialog::on_selectDirPathPushButton_clicked()
{


    this->ui->fileDirPathLineEdit->setText( QFileDialog::getExistingDirectory( this,
                                                           "Select keys Dir",
                                                           QDir::current().absolutePath()
                                                           ) );

}

void cNewKeyGenerationDialog::on_buttonBox_accepted()
{
    /// Calculate size in bytes
    int size = this->ui->keySizeSpinBox->value();
    switch ( this->ui->sizeTypeComboBox->currentIndex() ) {
    case 0:
    //Bytes. May generate too small keys. FIXME later
        break;
    case 1:
    //KBytes
        size = size*1024;
        break;
    case 2:
    //MBytes
        size = size*1024*1024;
        break;
    case 3:
    //GBytes !
        if ( size > 1 ) {
            // WARN! NO MORE THAN 1 Gb because of int size
            size = 1;
        }
        size = size * 1024*1024*1024;
        break;
    default:
        break;
    }
    qDebug()<<"size"<<size;


    cFinalKeyGenerator::sGenType::eGenType genType;

    if ( this->ui->FASTRadioButton->isChecked() ) genType = cFinalKeyGenerator::sGenType::FAST;
    if ( this->ui->NORMALRadioButton->isChecked() ) genType = cFinalKeyGenerator::sGenType::NORMAL;
    if ( this->ui->HARDENEDRadioButton->isChecked() ) genType = cFinalKeyGenerator::sGenType::PARANOIC;

    emit sendInnerData( size , this->ui->fileDirPathLineEdit->text(), genType);
}

void cNewKeyGenerationDialog::on_sizeTypeComboBox_currentIndexChanged(int index)
{
    /// Do not allow more than 1 gb keys
    if ( index == 3 )
    {
        ui->keySizeSpinBox->setMaximum(1);
    }
    else if ( index == 2 )
    {
        ui->keySizeSpinBox->setMaximum(1024);
    }
    else if ( index == 1 )
    {
        ui->keySizeSpinBox->setMaximum(1024*1024);
    }
    else
    {
         ui->keySizeSpinBox->setMaximum(1024*1024*1024);
    }


}

void cNewKeyGenerationDialog::on_fileDirPathLineEdit_textChanged(const QString &arg1)
{
    bool reset = true;
    QDir dir(arg1);
    if ( dir.exists() )
    {
        if ( dir.isReadable() )
        {
            reset = false;
            ui->buttonBox->setEnabled( true );
        }
    }

    if ( reset )
    {
        ui->buttonBox->setEnabled( false );
    }

}
