#include "randomstringinputdialog.h"
#include "ui_randomstringinputdialog.h"
#include <QMessageBox>
#include <QDebug>

cRandomStringInputDialog::cRandomStringInputDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::cRandomStringInputDialog),
    closeable_( false )
{
    ui->setupUi(this);
   // this->setWindowFlags( Qt::FramelessWindowHint|Qt::WindowTitleHint );
}

cRandomStringInputDialog::~cRandomStringInputDialog()
{
    delete ui;
}



void cRandomStringInputDialog::on_pushButton_clicked()
{
   // qDebug()<<"CLICK"<<ui->plainTextEdit->toPlainText().length();
    if ( ui->plainTextEdit->toPlainText().length()<10 )
    {
        QMessageBox box;
        box.setText("Text too short");
        box.setModal(true);

        box.setIcon( QMessageBox::Critical );
        box.exec();

    }
    else
    {

        this->hide();

        this->close();
        QApplication::processEvents();
        emit sendStringGenerationData( string_, dateTimes_);
        closeable_ = true;
    }

}

void cRandomStringInputDialog::on_plainTextEdit_textChanged()
{
    this->dateTimes_.append( QDateTime::currentDateTime() );
    this->string_ = ui->plainTextEdit->toPlainText();
}

void cRandomStringInputDialog::closeEvent( QCloseEvent *ev )
{

    if ( ! closeable_ ) {
        ev->ignore();
    } else {
        ev->accept();
    }
}
