/*
   QT Vernam, a program to implement Vernam algorythm for very strong file
   and message encryption.
   Copyright (C) 2014  Vokhmin Ivan <i_vohmin@mail.ru>

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>
*/
#ifndef RANDOMSTRINGINPUTDIALOG_H
#define RANDOMSTRINGINPUTDIALOG_H

#include <QDialog>
#include <QString>
#include <QList>
#include <QDateTime>
#include <QAbstractButton>

namespace Ui {
class cRandomStringInputDialog;
}

class cRandomStringInputDialog : public QDialog
{
    Q_OBJECT

public:
    explicit cRandomStringInputDialog(QWidget *parent = 0);
    ~cRandomStringInputDialog();

private slots:

    void on_pushButton_clicked();

    void on_plainTextEdit_textChanged();

signals:
    void sendStringGenerationData(QString string, QList<QDateTime> dateTimes);

private:

    void closeEvent( QCloseEvent * ev );
    Ui::cRandomStringInputDialog *ui;
    QString string_;
    QList<QDateTime> dateTimes_;
    bool closeable_;
};

#endif // RANDOMSTRINGINPUTDIALOG_H
