#include <QFileDialog>
#include <QMessageBox>

#include "textdecryptdialogform.h"
#include "ui_textdecryptdialogform.h"
#include "randomizer.h"
#include "magicbytes.h"

cTextDecryptDialogForm::cTextDecryptDialogForm(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::cTextDecryptDialogForm)
{
    ui->setupUi(this);
}

cTextDecryptDialogForm::~cTextDecryptDialogForm()
{
    delete ui;
}

void cTextDecryptDialogForm::on_keySelectButton_clicked()
{
    QString fileName = QFileDialog::getOpenFileName(this, tr("Open Receiver Key File"),
                                                    "",
                                                    tr("Receiver key files (*.rkey)"));
    ui->keyFileLineEdit->setText( fileName );

}

void cTextDecryptDialogForm::on_messageFileSelectButton_clicked()
{
    QString fileName = QFileDialog::getOpenFileName(this, tr("Open Message File"),
                                                    "",
                                                    tr("Message (*.ems)"));
    ui->messageFileLineEdit->setText( fileName );
}

void cTextDecryptDialogForm::on_doDecryptButton_clicked()
{

    QFile messageFile( ui->messageFileLineEdit->text() );
    QFile keyFile( ui->keyFileLineEdit->text() );

    if(( ! messageFile.open( QIODevice::ReadOnly ) ) ||
            ( ! keyFile.open( QIODevice::ReadOnly ) ) )
    {
        throw "can not open files";
    }



    QDataStream key(&keyFile);
    QDataStream mes(&messageFile);

    QByteArray ba;
    key >> ba;
    qint64 magicBit;
    qint64 pos;
    QByteArray mesText;
    mes >> magicBit >> pos >> mesText;
  //  qDebug() <<  magicBit << pos << mesText;
    /// MagicBit 778 - text 779 - file
    QByteArray keyPart;
    for ( int i = pos; i<pos+mesText.size(); i++ )
    {
        keyPart.append( ba.at(i) );
    }
   // qDebug()<<mesText;
   // qDebug()<<keyPart;
    if ( magicBit == TEXTSIG ) {
        QByteArray decryptedText = cFinalKeyGenerator::xOrByteArraysOfSameSize( &keyPart, &mesText );
    //    qDebug()<<QString(decryptedText.data());
        ui->mainTextEdit->setEnabled( true );
        ui->mainTextEdit->appendPlainText( QString( decryptedText.data() ) );
    }
    else if ( magicBit == FILESIG )
    {
        QByteArray decryptedData = cFinalKeyGenerator::xOrByteArraysOfSameSize( &keyPart, &mesText );
        QDataStream stream( &decryptedData, QIODevice::ReadOnly );
        QString name;
        QByteArray file;
        stream >> name >> file;
   //     qDebug()<<name;
        QString fileName = QFileDialog::getSaveFileName(this, QObject::tr("Open Message File"),
                                                        name,
                                                        name );
        if( fileName == "" ) return;
        QFile output( fileName );
        if ( ! output.open( QIODevice::WriteOnly ) )
        {
            QMessageBox msgBox;
             msgBox.setText("Can not write to output file.");
             msgBox.setIcon( QMessageBox::Critical );
             msgBox.exec();
             return;
        }

        output.write( file );
        output.close();




    }
    else
    {
        throw "Wrong Mbit";
    }
    messageFile.close();
    keyFile.close();

}

void cTextDecryptDialogForm::on_close_clicked()
{
    this->close();
}
